Scriptname ZAU_V5_AbsorptionScript extends activemagiceffect  

Actor SelfRef
Sound Property MagWardTestAbsorb Auto
GlobalVariable Property DLC1ReflectingShieldTimesHitGlobal Auto
GlobalVariable Property DLC1ReflectingShieldCurrentStageGlobal Auto
ImagespaceModifier Property DLC1ReflectingShieldChargeImod Auto
ImagespaceModifier Property DLC1ReflectingShieldBlastImod Auto
Sound Property ZAU_ShieldBlast01 Auto
Sound Property ZAU_ShieldBlast02 Auto
Sound Property ZAU_ShieldBlast03 Auto
Spell Property DLC1ReflectingShieldKnockback01 Auto
Spell Property DLC1ReflectingShieldKnockback02 Auto
Spell Property DLC1ReflectingShieldKnockback03 Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)	
	SelfRef = akCaster
	If (SelfRef == Game.GetPlayer())
		RegisterForAnimationEvent(selfRef, "bashRelease")
	Else
		RegisterForAnimationEvent(selfRef, "bashExit")
		RegisterForAnimationEvent(selfRef, "bashStop")
	EndIf
	SetAnimation(False)
EndEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
   	If abHitBlocked 
   		DLC1ReflectingShieldTimesHitGlobal.SetValue(DLC1ReflectingShieldTimesHitGlobal.GetValue() + 1)
   		MagWardTestAbsorb.play(selfRef) 
   		if (DLC1ReflectingShieldTimesHitGlobal.GetValue() == 5)
   			DLC1ReflectingShieldCurrentStageGlobal.SetValue(1)
			SetAnimation(True)
   		elseif (DLC1ReflectingShieldTimesHitGlobal.GetValue() == 10)
   			DLC1ReflectingShieldCurrentStageGlobal.SetValue(2)
			SetAnimation(True)
   		elseif (DLC1ReflectingShieldTimesHitGlobal.GetValue() == 15)
   			DLC1ReflectingShieldCurrentStageGlobal.SetValue(3)
			SetAnimation(True)
   		endif
   	EndIf
EndEvent
	
Event OnAnimationEvent(ObjectReference akSource, string EventName)
	If (SelfRef == Game.GetPlayer()) && (EventName == "bashRelease")
		if DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 1
			Blast(0.3, ZAU_ShieldBlast01, DLC1ReflectingShieldKnockback01)
		elseif DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 2
			Blast(0.6, ZAU_ShieldBlast02, DLC1ReflectingShieldKnockback02)
		elseif DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 3
			Blast(1.0, ZAU_ShieldBlast03, DLC1ReflectingShieldKnockback03)
		endif	
		SelfRef.SetSubGraphFloatVariable("fToggleBlend", 0)
		DLC1ReflectingShieldCurrentStageGlobal.SetValue(0)
		DLC1ReflectingShieldTimesHitGlobal.SetValue(0)
	ElseIf (EventName == "bashExit") || (EventName == "bashStop")
		if DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 1
			Blast(0, ZAU_ShieldBlast01, DLC1ReflectingShieldKnockback01)
		elseif DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 2
			Blast(0, ZAU_ShieldBlast02, DLC1ReflectingShieldKnockback02)
		elseif DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 3
			Blast(0, ZAU_ShieldBlast03, DLC1ReflectingShieldKnockback03)
		endif	
		SelfRef.SetSubGraphFloatVariable("fToggleBlend", 0)
		DLC1ReflectingShieldCurrentStageGlobal.SetValue(0)
		DLC1ReflectingShieldTimesHitGlobal.SetValue(0)
	EndIf
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)	
	UnregisterForAnimationEvent(selfRef, "bashRelease")
	UnregisterForAnimationEvent(selfRef, "bashExit")
	UnregisterForAnimationEvent(selfRef, "bashStop")
EndEvent

Function SetAnimation(Bool ApplyImod)
	If (SelfRef == Game.GetPlayer()) && (ApplyImod == True)
		DLC1ReflectingShieldChargeImod.Apply()
	EndIf
	If DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 1
		SelfRef.SetSubGraphFloatVariable("fDampRate", 1)
		SelfRef.SetSubGraphFloatVariable("fToggleBlend", 0.75)
	ElseIf DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 2
		SelfRef.SetSubGraphFloatVariable("fDampRate", 1)
		SelfRef.SetSubGraphFloatVariable("fToggleBlend", 0.85)
	ElseIf DLC1ReflectingShieldCurrentStageGlobal.GetValue() == 3
		SelfRef.SetSubGraphFloatVariable("fDampRate", 1)
		SelfRef.SetSubGraphFloatVariable("fToggleBlend", 1)
	EndIf
EndFunction

Function Blast(Float ImodDuration, Sound BlastSound, Spell BlastSpell)
	If ImodDuration > 0
		DLC1ReflectingShieldBlastImod.Apply(ImodDuration)
	EndIf
	BlastSound.Play(SelfRef)
	BlastSpell.Cast(SelfRef)
EndFunction