Scriptname ZCV_V6_Gloomwatch extends activemagiceffect

Actor TargetActor
String Property Archetype Auto
Spell Property ZArticulation_DetectLife Auto
EffectShader Property ZArticulation_DetectLifeEffect_HitEffectFX01 Auto
EffectShader Property ZArticulation_DetectLifeEffect_HitEffectFX02 Auto
EffectShader Property ZArticulation_DetectLifeEffect_HitEffectFX03 Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	TargetActor = akTarget
	GoToState(Archetype)
EndEvent

STATE Enchantment
Event OnBeginState()
	TargetActor.AddSpell(ZArticulation_DetectLife, False)
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	TargetActor.RemoveSpell(ZArticulation_DetectLife)
EndEvent
ENDSTATE

STATE LesserPower
Event OnBeginState()
	If TargetActor.HasSpell(ZArticulation_DetectLife)
		TargetActor.RemoveSpell(ZArticulation_DetectLife)
	Else
		TargetActor.AddSpell(ZArticulation_DetectLife, False)
	EndIf
EndEvent
ENDSTATE

STATE HitSpell
Event OnBeginState()
	Glow()
EndEvent

Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	Glow()
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	UnGlow()
EndEvent

Event OnDying(Actor akKiller)
	UnGlow()
EndEvent
ENDSTATE

Function Glow()
UnGlow()
If TargetActor.IsDead() == False
	If TargetActor.GetCombatState() == 0 ;Not in combat
		ZArticulation_DetectLifeEffect_HitEffectFX01.Play(TargetActor)
	ElseIf TargetActor.GetCombatState() == 1 ;In combat
		ZArticulation_DetectLifeEffect_HitEffectFX03.Play(TargetActor)
	ElseIf TargetActor.GetCombatState() == 2 ;Searching
		ZArticulation_DetectLifeEffect_HitEffectFX02.Play(TargetActor)
	EndIf
EndIf
EndFunction

Function UnGlow()
	ZArticulation_DetectLifeEffect_HitEffectFX01.Stop(TargetActor)
	ZArticulation_DetectLifeEffect_HitEffectFX02.Stop(TargetActor)
	ZArticulation_DetectLifeEffect_HitEffectFX03.Stop(TargetActor)
EndFunction