Scriptname ZOI_V6_OghmaAliasScript extends ReferenceAlias

Actor PlayerActor
Book Property ZOI_OghmaInfinium Auto
Book Property DA04OghmaInfinium Auto

Event OnInit()
	PlayerActor = Game.GetPlayer()
	If PlayerActor.GetItemCount(DA04OghmaInfinium) >= 1
		OghmaAcquired()
		GoToState("Dormant")
	Else
	AddInventoryEventFilter(DA04OghmaInfinium)
	GoToState("Waiting")
	Endif
EndEvent

;--------------------------------------------------------------------------------------------------------
STATE Waiting
;--------------------------------------------------------------------------------------------------------
Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
If akBaseItem == DA04OghmaInfinium
	OghmaAcquired()
Endif
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If akDestContainer
		akDestContainer.RemoveItem(akBaseItem, aiItemCount, True, None)
	EndIf
	GoToState("Dormant")
EndEvent
ENDSTATE

Function OghmaAcquired()
	PlayerActor.RemoveItem(DA04OghmaInfinium,(PlayerActor.GetItemCount(DA04OghmaInfinium)),True)
	PlayerActor.AddItem(ZOI_OghmaInfinium,1,True)
EndFunction

;--------------------------------------------------------------------------------------------------------
GlobalVariable Property ZOI_SoulMin Auto ;Minimum number of souls require to unlock perks
GlobalVariable Property ZOI_SoulPerks Auto ;Number of perks unlocked per use
GlobalVariable Property ZOI_SoulMax Auto ;Maximum number of perks that can be unlocked
Message Property ZOI_ModMessage_MainL Auto
Message Property ZOI_ModMessage_MainU Auto
Message Property ZOI_ModMessage_SoulMin Auto
Message Property ZOI_ModMessage_SoulPerks Auto
Message Property ZOI_ModMessage_SoulMaxL Auto
Message Property ZOI_ModMessage_SoulMaxU Auto
;--------------------------------------------------------------------------------------------------------
STATE Modify
;--------------------------------------------------------------------------------------------------------
Event OnBeginState()
	MainOption()
EndEvent
ENDSTATE

Function MainOption()
	Int MessageOption = ChooseStartingMessage(ZOI_ModMessage_MainU, ZOI_ModMessage_MainL).Show(ZOI_SoulMin.GetValueInt(), ZOI_SoulPerks.GetValueInt(), ZOI_SoulMax.GetValueInt())
	If MessageOption == 0;Modify minimum souls
		SubOption(ZOI_ModMessage_SoulMin, ZOI_SoulMin, 1, False)
	ElseIf MessageOption == 1;Modify perk points
		SubOption(ZOI_ModMessage_SoulPerks, ZOI_SoulPerks, 1, False)
	ElseIf MessageOption == 2;Modify maximum perk points
		SubOption(ChooseStartingMessage(ZOI_ModMessage_SoulMaxU, ZOI_ModMessage_SoulMaxL), ZOI_SoulMax, 0, True)
	Else
		GoToState("Dormant")
	EndIf
EndFunction

Message Function ChooseStartingMessage(Message UnlimitedOption, Message LimitedOption)
	If ZOI_SoulMax.GetValueInt() <= 0
		Return UnlimitedOption
	Else
		Return LimitedOption
	EndIf
EndFunction

Function SubOption(Message SubMessage, GlobalVariable SubGlobal, Int DefaultValue, Bool IsMax)
	Int SubMessageChoice = SubMessage.Show(SubGlobal.GetValueInt())
	If SubMessageChoice == 0
		MainOption()
	Else
		If SubMessageChoice == 1;Default
			SubGlobal.SetValue(DefaultValue)
		ElseIf SubMessageChoice == 2
			SubGlobal.SetValue(SubGlobal.GetValueInt() + 1)
		ElseIf SubMessageChoice == 3
			If !IsMax || SubGlobal.GetValueInt() != 0
				SubGlobal.SetValue(SubGlobal.GetValueInt() - 1)
			Else
				SubGlobal.SetValue(249)
			EndIf
		ElseIf SubMessageChoice == 4
			SubGlobal.SetValue(SubGlobal.GetValueInt() + 10)
		ElseIf SubMessageChoice == 5
			If !IsMax || SubGlobal.GetValueInt() != 0
				SubGlobal.SetValue(SubGlobal.GetValueInt() - 10)
			Else
				SubGlobal.SetValue(240)
			EndIf
		EndIf
		If !IsMax
			SubOption(SubMessage, SubGlobal, DefaultValue, IsMax)
		Else
			SubOption(ChooseStartingMessage(ZOI_ModMessage_SoulMaxU, ZOI_ModMessage_SoulMaxL), SubGlobal, DefaultValue, IsMax)
		EndIf
	EndIf
EndFunction

;--------------------------------------------------------------------------------------------------------
STATE Dormant
;--------------------------------------------------------------------------------------------------------
ENDSTATE