Scriptname ZOI_V6_OghmaSpellScript extends activemagiceffect  

String Property SpellType Auto ; Power, Ability, Modify
Actor PlayerActor

Event OnEffectStart(Actor akTarget, Actor akCaster)
If akTarget == Game.GetPlayer()
	PlayerActor = akTarget
	GoToState(SpellType)
EndIf
EndEvent

;--------------------------------------------------------------------------------------------------------
STATE Modify
;--------------------------------------------------------------------------------------------------------
Event OnBeginState()
	If (OghmaPlayerRef as ZOI_V6_OghmaAliasScript).GetState() == "Dormant"
		(OghmaPlayerRef as ZOI_V6_OghmaAliasScript).GoToState("Modify")
	EndIf
EndEvent
ENDSTATE

;--------------------------------------------------------------------------------------------------------
GlobalVariable Property ZOI_SoulMin Auto
GlobalVariable Property ZOI_SoulPerks Auto
GlobalVariable Property ZOI_SoulMax Auto
GlobalVariable Property ZOI_SoulsUnlocked Auto
EffectShader Property ZOI_EffectShader Auto
ImageSpaceModifier Property ZOI_Imod Auto
Sound Property MAGFail Auto
Sound Property ZOI_SuccessSound Auto
Sound Property NPCDragonFlightRoarDistant01 Auto
ReferenceAlias Property OghmaPlayerRef Auto
Int RequiredSouls
;--------------------------------------------------------------------------------------------------------
STATE Power
;--------------------------------------------------------------------------------------------------------
Event OnBeginState()
RequiredSouls = (ZOI_SoulMin.GetValueInt())
IF PlayerActor.GetActorValue("DragonSouls") >= RequiredSouls
	PlayerActor.DamageActorValue("DragonSouls", RequiredSouls)
	ZOI_EffectShader.Play(PlayerActor,2)
	ZOI_Imod.Apply()
	ZOI_SuccessSound.Play(PlayerActor)
	Game.ShakeCamera(PlayerActor, 0.5, 1)
	Game.ShakeController(0.5, 0.5, 1)
	AddDragonPerks()
	CheckMaximum()
	Utility.Wait(1.25)
	NPCDragonFlightRoarDistant01.Play(PlayerActor)
ELSE
	MAGFail.Play(PlayerActor)
	If RequiredSouls == 1
		Debug.Notification("You need a dragon soul to use this power.")
	Else
		Debug.Notification("You need "+RequiredSouls+" dragon souls to use this power.")
	Endif
ENDIF
EndEvent
ENDSTATE

Function AddDragonPerks()
	Int RequestedPerks = (ZOI_SoulPerks.GetValueInt())
	Int RemainingPerks = (ZOI_SoulMax.GetValueInt() - ZOI_SoulsUnlocked.GetValueInt())
	Int SoulsToUnlock
	If (RemainingPerks > RequestedPerks) || (ZOI_SoulMax.GetValue() <= 0)
		SoulsToUnlock = RequestedPerks
	Else
		SoulsToUnlock = RemainingPerks
	EndIf
	Game.AddPerkPoints(SoulsToUnlock)
	ZOI_SoulsUnlocked.SetValue(ZOI_SoulsUnlocked.GetValueInt()+SoulsToUnlock)
EndFunction

Function CheckMaximum()
	If (ZOI_SoulMax.GetValue() > 0) 
		If (ZOI_SoulsUnlocked.GetValue() >= ZOI_SoulMax.GetValue())
			PlayerActor.RemoveSpell(ZOI_Dragon02_Power)
			(SwitchAlias as ZIA_06_SwitchScript).GoToState("NoPossession")
			Debug.Notification("You have leaned all you can from Dragon Knowledge.")
		Else
			Debug.Notification(ZOI_SoulsUnlocked.GetValueInt()+"/"+ZOI_SoulMax.GetValueInt()+" perks unlocked.")
		EndIf
	EndIf
EndFunction

;--------------------------------------------------------------------------------------------------------
Spell Property ZOI_Dragon02_Power Auto
ReferenceAlias Property SwitchAlias Auto
Int LevelIndicator
Int BaseIndicatorValue
String CurrentSkill
Bool LevelUpSkill
Bool ChecksCompleted = False
Bool OneHandedChecked = False
Bool TwoHandedChecked = False
Bool MarksmanChecked = False
Bool BlockChecked = False
Bool SmithingChecked = False
Bool HeavyArmorChecked = False
Bool LightArmorChecked = False
Bool PickpocketChecked = False
Bool LockpickingChecked = False
Bool SneakChecked = False
Bool AlchemyChecked = False
Bool SpeechcraftChecked = False
Bool AlterationChecked = False
Bool ConjurationChecked = False
Bool DestructionChecked = False
Bool IllusionChecked = False
Bool RestorationChecked = False
Bool EnchantingChecked = False
;--------------------------------------------------------------------------------------------------------
STATE Ability
;--------------------------------------------------------------------------------------------------------
Event OnBeginState()
PlayerActor.AddSpell(ZOI_Dragon02_Power,False)
(SwitchAlias as ZIA_06_SwitchScript).GoToState("Received")
Int SkillOneHanded = PlayerActor.GetActorValue("OneHanded") as Int
Int SkillTwoHanded = PlayerActor.GetActorValue("TwoHanded") as Int
Int SkillMarksman = PlayerActor.GetActorValue("Marksman") as Int
Int SkillBlock = PlayerActor.GetActorValue("Block") as Int
Int SkillSmithing = PlayerActor.GetActorValue("Smithing") as Int
Int SkillHeavyArmor = PlayerActor.GetActorValue("HeavyArmor") as Int
Int SkillLightArmor = PlayerActor.GetActorValue("LightArmor") as Int
Int SkillPickpocket = PlayerActor.GetActorValue("Pickpocket") as Int
Int SkillLockpicking = PlayerActor.GetActorValue("Lockpicking") as Int
Int SkillSneak = PlayerActor.GetActorValue("Sneak") as Int
Int SkillAlchemy = PlayerActor.GetActorValue("Alchemy") as Int
Int SkillSpeechcraft = PlayerActor.GetActorValue("Speechcraft") as Int
Int SkillAlteration = PlayerActor.GetActorValue("Alteration") as Int
Int SkillConjuration = PlayerActor.GetActorValue("Conjuration") as Int
Int SkillDestruction = PlayerActor.GetActorValue("Destruction") as Int
Int SkillIllusion = PlayerActor.GetActorValue("Illusion") as Int
Int SkillRestoration = PlayerActor.GetActorValue("Restoration") as Int
Int SkillEnchanting = PlayerActor.GetActorValue("Enchanting") as Int

		If (SkillOneHanded == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			OneHandedChecked = True
		Endif
		If (SkillTwoHanded  == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			TwoHandedChecked = True
		Endif
		If (SkillMarksman == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			MarksmanChecked = True
		Endif
		If (SkillBlock == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			BlockChecked = True
		Endif
		If (SkillSmithing == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			SmithingChecked = True
		Endif
		If (SkillHeavyArmor == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			HeavyArmorChecked = True
		Endif
		If (SkillLightArmor == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			LightArmorChecked = True
		Endif
		If (SkillPickpocket == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			PickpocketChecked = True
		Endif
		If (SkillLockpicking == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			LockpickingChecked = True
		Endif
		If (SkillSneak == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			SneakChecked = True
		Endif
		If (SkillAlchemy == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			AlchemyChecked = True
		Endif
		If (SkillSpeechcraft == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			SpeechcraftChecked = True
		Endif
		If (SkillAlteration == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			AlterationChecked = True
		Endif
		If (SkillConjuration == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			ConjurationChecked = True
		Endif
		If (SkillDestruction == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			DestructionChecked = True
		Endif
		If (SkillIllusion == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			IllusionChecked = True
		Endif
		If (SkillRestoration == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			RestorationChecked = True
		Endif
		If (SkillEnchanting == 100)
			BaseIndicatorValue = BaseIndicatorValue+1
			EnchantingChecked = True
		Endif

	ChooseSkill()
	WHILE ChecksCompleted == False
		LevelIndicator = BaseIndicatorValue
		LevelUpSkill = False
		Int CurrentActorValue = PlayerActor.GetActorValue(CurrentSkill) as Int
		If (CurrentActorValue  >= SkillOneHanded) && !(CurrentSkill == "OneHanded")
			LevelIndicator=(LevelIndicator+1)
		Endif
		If (CurrentActorValue  >= SkillTwoHanded) && !(CurrentSkill == "TwoHanded")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillMarksman) && !(CurrentSkill == "Marksman")
			LevelIndicator=(LevelIndicator+1)		
		Endif
		If (CurrentActorValue  >= SkillBlock) && !(CurrentSkill == "Block")
			LevelIndicator=(LevelIndicator+1)		
		Endif
		If (CurrentActorValue  >= SkillSmithing) && !(CurrentSkill == "Smithing")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillHeavyArmor) && !(CurrentSkill == "HeavyArmor")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillLightArmor) && !(CurrentSkill == "LightArmor")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillPickpocket) && !(CurrentSkill == "Pickpocket")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillLockpicking) && !(CurrentSkill == "Lockpicking")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillSneak) && !(CurrentSkill == "Sneak")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillAlchemy) && !(CurrentSkill == "Alchemy")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillSpeechcraft) && !(CurrentSkill == "Speechcraft")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillAlteration) && !(CurrentSkill == "Alteration")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillConjuration) && !(CurrentSkill == "Conjuration")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillDestruction) && !(CurrentSkill == "Destruction")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillIllusion) && !(CurrentSkill == "Illusion")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillRestoration) && !(CurrentSkill == "Restoration")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If (CurrentActorValue  >= SkillEnchanting) && !(CurrentSkill == "Enchanting")
			LevelIndicator=(LevelIndicator+1)	
		Endif
		If LevelIndicator >= 12
			Game.IncrementSkillBy(CurrentSkill,10)
		Endif
			If CurrentSkill == "OneHanded"
				OneHandedChecked = True
			ElseIf CurrentSkill == "TwoHanded"
				TwoHandedChecked = True
			ElseIf CurrentSkill == "Marksman"
				MarksmanChecked = True
			ElseIf CurrentSkill == "Block"
				BlockChecked = True
			ElseIf CurrentSkill == "Smithing"
				SmithingChecked = True
			ElseIf CurrentSkill == "HeavyArmor"
				HeavyArmorChecked = True
			ElseIf CurrentSkill == "LightArmor"
				LightArmorChecked = True
			ElseIf CurrentSkill == "Pickpocket"
				PickpocketChecked = True
			ElseIf CurrentSkill == "Lockpicking"
				LockpickingChecked = True
			ElseIf CurrentSkill == "Sneak"
				SneakChecked = True
			ElseIf CurrentSkill == "Alchemy"
				AlchemyChecked = True
			ElseIf CurrentSkill == "Speechcraft"
				SpeechcraftChecked = True
			ElseIf CurrentSkill == "Alteration"
				AlterationChecked = True
			ElseIf CurrentSkill == "Conjuration"
				ConjurationChecked = True
			ElseIf CurrentSkill == "Destruction"
				DestructionChecked = True
			ElseIf CurrentSkill == "Illusion"
				IllusionChecked = True
			ElseIf CurrentSkill == "Restoration"
				RestorationChecked = True
			ElseIf CurrentSkill == "Enchanting"
				EnchantingChecked = True
			Endif
		ChooseSkill()
	ENDWHILE
	Dispel()
EndEvent
ENDSTATE

Function ChooseSkill()
	IF OneHandedChecked == False
		CurrentSkill = "OneHanded"
	ELSEIF TwoHandedChecked == False
		CurrentSkill = "TwoHanded"
	ELSEIF MarksmanChecked == False
		CurrentSkill = "Marksman"
	ELSEIF BlockChecked == False
		CurrentSkill = "Block"
	ELSEIF SmithingChecked == False
		CurrentSkill = "Smithing"
	ELSEIF HeavyArmorChecked == False
		CurrentSkill = "HeavyArmor"
	ELSEIF LightArmorChecked == False
		CurrentSkill = "LightArmor"
	ELSEIF PickpocketChecked == False
		CurrentSkill = "Pickpocket"
	ELSEIF LockpickingChecked == False
		CurrentSkill = "Lockpicking"
	ELSEIF SneakChecked == False
		CurrentSkill = "Sneak"
	ELSEIF AlchemyChecked == False
		CurrentSkill = "Alchemy"
	ELSEIF SpeechcraftChecked == False
		CurrentSkill = "Speechcraft"
	ELSEIF AlterationChecked == False
		CurrentSkill = "Alteration"
	ELSEIF ConjurationChecked == False
		CurrentSkill = "Conjuration"
	ELSEIF DestructionChecked == False
		CurrentSkill = "Destruction"
	ELSEIF IllusionChecked == False
		CurrentSkill = "Illusion"
	ELSEIF RestorationChecked == False
		CurrentSkill = "Restoration"
	ELSEIF EnchantingChecked == False
		CurrentSkill = "Enchanting"
	ELSE
		ChecksCompleted = True
	ENDIF
EndFunction