Scriptname ZTH_V6_PlayerAliasScript extends ReferenceAlias  

Quest Property FavorJarlsMakeFriends Auto
FormList Property ZTh_ThanePerks Auto

ReferenceAlias Property WinterholdWeapon Auto
ReferenceAlias Property EastmarchWeapon Auto
ReferenceAlias Property FalkreathWeapon Auto
ReferenceAlias Property PaleWeapon Auto
ReferenceAlias Property ReachWeapon Auto
ReferenceAlias Property HjaalmarchWeapon Auto
ReferenceAlias Property HaafingarWeapon Auto
ReferenceAlias Property WhiterunWeapon01 Auto
ReferenceAlias Property WhiterunWeapon02 Auto
ReferenceAlias Property RiftWeapon Auto

Weapon Property ZTh_01_Winterhold00 Auto
Weapon Property ZTh_02_Eastmarch00 Auto
Weapon Property ZTh_03_Falkreath00 Auto
Weapon Property ZTh_04_ThePale00 Auto
Weapon Property ZTh_05_TheReach00 Auto
Weapon Property ZTh_06_Hjaalmarch00 Auto
Weapon Property ZTh_07_Haafingar00 Auto
Weapon Property ZTh_08_Whiterun00 Auto
Weapon Property ZTh_09_Rift00 Auto

Armor Property ZTH_10_ThaneContainer_Winterhold Auto
Armor Property ZTH_10_ThaneContainer_Eastmarch Auto
Armor Property ZTH_10_ThaneContainer_Falkreath Auto
Armor Property ZTH_10_ThaneContainer_Haafingar Auto
Armor Property ZTH_10_ThaneContainer_Hjaalmarch Auto
Armor Property ZTH_10_ThaneContainer_Pale Auto
Armor Property ZTH_10_ThaneContainer_Reach Auto
Armor Property ZTH_10_ThaneContainer_Rift Auto
Armor Property ZTH_10_ThaneContainer_Whiterun Auto

ObjectReference OldThaneWeapon
Weapon NewThaneWeapon
Actor PlayerActor

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	IF ((akItemReference == WinterholdWeapon.GetRef() as ObjectReference) && !(WinterholdWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Winterhold)
		OldThaneWeapon = WinterholdWeapon.GetRef()
		NewThaneWeapon = ZTh_01_Winterhold00
 		OldForNew(ZTH_10_ThaneContainer_Winterhold)

	ELSEIF ((akItemReference == EastmarchWeapon.GetRef() as ObjectReference) && !(EastmarchWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Eastmarch)
		OldThaneWeapon = EastmarchWeapon.GetRef()
		NewThaneWeapon = ZTh_02_Eastmarch00
 		OldForNew(ZTH_10_ThaneContainer_Eastmarch)

	ELSEIF ((akItemReference == FalkreathWeapon.GetRef() as ObjectReference) && !(FalkreathWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Falkreath)
		OldThaneWeapon = FalkreathWeapon.GetRef()
		NewThaneWeapon = ZTh_03_Falkreath00
 		OldForNew(ZTH_10_ThaneContainer_Falkreath)

	ELSEIF ((akItemReference == PaleWeapon.GetRef() as ObjectReference) && !(PaleWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Pale)
		OldThaneWeapon = PaleWeapon.GetRef()
		NewThaneWeapon = ZTh_04_ThePale00
 		OldForNew(ZTH_10_ThaneContainer_Pale)

	ELSEIF ((akItemReference == ReachWeapon.GetRef() as ObjectReference) && !(ReachWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Reach)
		OldThaneWeapon = ReachWeapon.GetRef()
		NewThaneWeapon = ZTh_05_TheReach00
 		OldForNew(ZTH_10_ThaneContainer_Reach)

	ELSEIF ((akItemReference == HjaalmarchWeapon.GetRef() as ObjectReference) && !(HjaalmarchWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Hjaalmarch)
		OldThaneWeapon = HjaalmarchWeapon.GetRef()
		NewThaneWeapon = ZTh_06_Hjaalmarch00
 		OldForNew(ZTH_10_ThaneContainer_Hjaalmarch)

	ELSEIF ((akItemReference == HaafingarWeapon.GetRef() as ObjectReference) && !(HaafingarWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Haafingar)
		OldThaneWeapon = HaafingarWeapon.GetRef()
		NewThaneWeapon = ZTh_07_Haafingar00
 		OldForNew(ZTH_10_ThaneContainer_Haafingar)

	ELSEIF ((akItemReference == WhiterunWeapon01.GetRef() as ObjectReference) && !(WhiterunWeapon01.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Whiterun)
		OldThaneWeapon = WhiterunWeapon01.GetRef()
		NewThaneWeapon = ZTh_08_Whiterun00
 		OldForNew(ZTH_10_ThaneContainer_Whiterun)

	ELSEIF ((akItemReference == WhiterunWeapon02.GetRef() as ObjectReference) && !(WhiterunWeapon02.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Whiterun)
		OldThaneWeapon = WhiterunWeapon02.GetRef()		
		NewThaneWeapon = ZTh_08_Whiterun00
 		OldForNew(ZTH_10_ThaneContainer_Whiterun)

	ELSEIF ((akItemReference == RiftWeapon.GetRef() as ObjectReference) && !(RiftWeapon.GetRef() == None)) || (akBaseItem == ZTH_10_ThaneContainer_Rift)
		OldThaneWeapon = RiftWeapon.GetRef()
		NewThaneWeapon = ZTh_09_Rift00
 		OldForNew(ZTH_10_ThaneContainer_Rift)

	ENDIF
EndEvent

Event OnInit()
	PlayerActor = Game.GetPlayer()
	Int WhileInt = 0
	WHILE WhileInt < ZTh_ThanePerks.GetSize()
		PlayerActor.AddPerk(ZTh_ThanePerks.GetAt(WhileInt) as Perk)
		WhileInt += 1
	ENDWHILE
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If akDestContainer && (akBaseItem == OldThaneWeapon)
		akDestContainer.RemoveItem(akBaseItem, aiItemCount, True, None)
	EndIf
EndEvent

Function OldForNew(Armor RepresentArmor)
	PlayerActor.RemoveItem(OldThaneWeapon, 1, True)
	PlayerActor.AddItem(NewThaneWeapon)
	IF RepresentArmor
		If PlayerActor.GetItemCount(RepresentArmor) > 0
			PlayerActor.RemoveItem(RepresentArmor, 1, True)
		Endif
	ENDIF
EndFunction

