Scriptname ZWJ_V5_PolymorphScript extends ActiveMagicEffect

Actor TargetActor
ActorBase Property ZWJ_Polymorph09_DremoraBard Auto
ActorBase Property ZWJ_Polymorph72_GhostBard Auto
ActorBase Property ZWJ_Polymorph76_ZombieBard Auto
Cell Property ZWJ_Music Auto
EffectShader Property GhostFXShader Auto
Idle Property IdleFluteStart Auto
Idle Property IdleLuteStart Auto
Idle Property IdleDrumStart Auto
ObjectReference Property ZWJ_FluteMusic Auto
ObjectReference Property ZWJ_LuteMusic Auto
ObjectReference Property ZWJ_DrumMusic Auto
ObjectReference MusicRef

Event OnEffectStart(Actor akTarget, Actor akCaster)
TargetActor = akTarget
	If akTarget.GetActorBase() == ZWJ_Polymorph09_DremoraBard
		BeginMusic(IdleFluteStart, ZWJ_FluteMusic)
		RegisterForSingleUpdate(10)
	ElseIf akTarget.GetActorBase() == ZWJ_Polymorph72_GhostBard
		BeginMusic(IdleLuteStart, ZWJ_LuteMusic)
		RegisterForSingleUpdate(10)
		Utility.Wait(0.1)
		GhostFXShader.Play(akTarget)
	ElseIf akTarget.GetActorBase() == ZWJ_Polymorph76_ZombieBard
		BeginMusic(IdleDrumStart, ZWJ_DrumMusic)
		RegisterForSingleUpdate(10)
	EndIf
	akTarget.BlockActivation()
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If (akDestContainer as Actor)
		akDestContainer.RemoveItem(akItemReference)
	Else
		akItemReference.Delete()
	EndIf
EndEvent

Event OnDying(Actor akKiller)
	DisableMusic()
	GetCasterActor().Activate(GetTargetActor())
EndEvent

Event OnUpdate()
	DisableMusic()
	GetCasterActor().Activate(GetTargetActor())
EndEvent

Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	DisableMusic()
EndEvent

Event OnActivate(ObjectReference akTriggerRef)
	If akTriggerRef == (TargetActor as ObjectReference)
		DisableMusic()
	EndIf
EndEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack,  bool abBashAttack, bool abHitBlocked)
	DisableMusic()
EndEvent

Function BeginMusic(Idle MusicIdle, ObjectReference MusicObject)
MusicRef = MusicObject
	If (MusicObject.GetParentCell()) == ZWJ_Music
		Int WhileCounter = 15
		WHILE WhileCounter > 0
			If TargetActor.PlayIdle(MusicIdle)
				WhileCounter = 0
			Else
				WhileCounter -= 1
				Utility.Wait(0.1)
			EndIf
		ENDWHILE
		If (TargetActor.GetCombatState() == 0)
			MusicRef.MoveTo(TargetActor)
		EndIf
	Else
		AllowCombat()
	EndIf
EndFunction

Function DisableMusic()
	If MusicRef
		MusicRef.MoveToMyEditorLocation()
	EndIf
	AllowCombat()
EndFunction

Function AllowCombat()
	If (TargetActor.GetActorValue("Aggression") == 0)
		TargetActor.SetActorValue("Aggression", 2)
	EndIf
	TargetActor.EvaluatePackage()
EndFunction