Scriptname ZWP_V6_QuestScript extends Quest  

ReferenceAlias Property WhitePhialPotion Auto
ObjectReference UninstallThrowAliasRef
ObjectReference PhialAliasRef

Event OnInit()
	UninstallThrowAliasRef = (GetAlias(21) as ReferenceAlias).GetRef()
	PhialAliasRef = (GetAlias(12) as ReferenceAlias).GetRef()
	PhialAliasRef.SetActorOwner(Game.GetPlayer().GetActorBase())
	UninstallThrowAliasRef.SetActorOwner(Game.GetPlayer().GetActorBase())
	If WhitePhialPotion.GetRef() != None ;Phial has been reforged
		StartPhial(False,(MS12PostQuest as MS12PostQuestScript).Replicated)
	EndIf
EndEvent

;-------------------------------------------------------------------------
;	USAGE
;-------------------------------------------------------------------------
Message Property MS12RefillMessage Auto
Form Property CurrentPotion Auto
;-------------------------------------------------------------------------
Function Refill()
	PhialAliasRef.AddItem(CurrentPotion)
	MS12RefillMessage.Show()
EndFunction

Function Realign(Form NewPotion)
	CurrentPotion = NewPotion
EndFunction

Function CheckPhial()
	PhialAliasRef.Activate(Game.GetPlayer())
EndFunction

;-------------------------------------------------------------------------
;	STARTUP
;-------------------------------------------------------------------------
GlobalVariable Property ZWP_Restored Auto
;-------------------------------------------------------------------------
Function StartPhial(Bool UpdateOnObtained, Potion BasePhial)
	ZWP_Restored.SetValue(0)	
	RegisterForSingleUpdate(5)
	ReplacePhial(UpdateOnObtained, BasePhial)
	CurrentPotion = FindStarterPotion(BasePhial)
	Refill()
EndFunction

Event OnUpdate()
	SetStage(5)
EndEvent
;-------------------------------------------------------------------------
MiscObject Property ZWP_WhitePhialRepaired Auto
Static Property XMarker Auto
;-------------------------------------------------------------------------
Function ReplacePhial(Bool UpdateOnObtained, Potion BasePhial)
	If UpdateOnObtained
		Game.GetPlayer().RemoveItem(BasePhial, 1, True, UninstallThrowAliasRef)
		Game.GetPlayer().AddItem(ZWP_WhitePhialRepaired,1,True)
	ElseIf (WhitePhialPotion as MS12WhitePhialScript).CurrentContainer == None
		ObjectReference PhialMarker = WhitePhialPotion.GetRef().PlaceAtMe(XMarker) as ObjectReference
		UninstallThrowAliasRef.AddItem(WhitePhialPotion.GetRef())
		PhialMarker.PlaceAtMe(ZWP_WhitePhialRepaired)
		PhialMarker.Delete()
	Else
		(WhitePhialPotion as MS12WhitePhialScript).CurrentContainer.RemoveItem(BasePhial, 1, True, UninstallThrowAliasRef)
		(WhitePhialPotion as MS12WhitePhialScript).CurrentContainer.AddItem(ZWP_WhitePhialRepaired,1,True)
	EndIf
EndFunction
;-------------------------------------------------------------------------
Potion Property MS12WPFortifyMagicka01 Auto
Potion Property MS12WPFortifySkillOneHanded04 Auto
Potion Property MS12WPFortifySkillSneak03 Auto
Potion Property MS12WPFortifyStamina01 Auto
Potion Property MS12WPResistMagic50 Auto
Potion Property FortifyMagicka05 Auto
Potion Property FortifySkillOneHanded04 Auto
Potion Property FortifySkillSneak04 Auto
Potion Property FortifyStaminaRate05 Auto
Potion Property ResistMagic100 Auto
Potion Property RestoreHealth05 Auto
Quest Property MS12PostQuest Auto
;-------------------------------------------------------------------------
Potion Function FindStarterPotion(Potion BasePhial)
	Potion StarterPotion = BasePhial
	If StarterPotion == MS12WPFortifyMagicka01
		Return FortifyMagicka05
	ElseIf StarterPotion == MS12WPFortifySkillOneHanded04
		Return FortifySkillOneHanded04
	ElseIf StarterPotion == MS12WPFortifySkillSneak03
		Return FortifySkillSneak04
	ElseIf StarterPotion == MS12WPFortifyStamina01
		Return FortifyStaminaRate05
	ElseIf StarterPotion == MS12WPResistMagic50
		Return ResistMagic100
	Else
		Return RestoreHealth05
	EndIf
EndFunction